//##############################################################################################################//
#include "CmnHdr.h"

#include <windows.h>
#include <tchar.h>
#include <Winsock2.h>
#ifndef UNICODE
#include <stdio.h>
#endif

//###############################################################################################################//
#pragma comment( lib, "ws2_32" )

//###############################################################################################################//
#define HEADER_SIZE ( 4 + MAX_PATH )

//###############################################################################################################//
VOID Start( PSTR pszServerIP, DWORD dwServerPort, PSTR pszFileName )
{
    BYTE         bBuffer[BUF_SIZE]  = {0};
    SOCKET       Socket             = INVALID_SOCKET;
    sockaddr_in  server             = {0};
    hostent     *host               = NULL;
    int          iRet               = 0;
    DWORD        dwDataSize         = 0;
    DWORD        dwBytesTransferred = 0;
    DWORD        dwSize             = 0;
    HANDLE       hFile              = INVALID_HANDLE_VALUE;

    server.sin_family      = AF_INET;
    server.sin_port        = htons( dwServerPort );
    server.sin_addr.s_addr = inet_addr( pszServerIP );

    __try{
        hFile = CreateFileA( pszFileName, GENERIC_READ, FILE_SHARE_READ, NULL,
                             OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
        if( INVALID_HANDLE_VALUE == hFile ){
            _tprintf( TEXT("\r\nCreateFile(): %d\r\n\r\n"), GetLastError() ); __leave;
            }

        dwDataSize = HEADER_SIZE + GetFileSize( hFile, NULL );

        // Search for the file in path.
        DWORD dwLen = lstrlenA( pszFileName );
        while( ( pszFileName[dwLen] != '\\' ) && dwLen-- );
        lstrcpyA( (PSTR) &bBuffer[4], &pszFileName[++dwLen] );

        CopyMemory( bBuffer, &dwDataSize, sizeof( dwDataSize ) );

        WSADATA wsd = {0};
        WSAStartup( MAKEWORD( 2,2 ), &wsd );

        Socket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );
        if( INVALID_SOCKET == Socket ){
            _tprintf( TEXT("\r\nsocket(): %d\r\n\r\n"), WSAGetLastError() ); __leave;
            }

        if( connect( Socket, (sockaddr*) &server, sizeof( server ) ) == SOCKET_ERROR ){
            _tprintf( TEXT("\r\nconnect(): %d\r\n\r\n"), WSAGetLastError() ); __leave;
            }

        _tprintf( TEXT("\r\n") );

        // Preparing and sending information about the file.
        DWORD dwLeft  = HEADER_SIZE;
        DWORD dwIndex = 0;
        while( dwLeft > 0 ){
            iRet = send( Socket, (char*) &bBuffer[dwIndex], dwLeft, 0 );
            if( SOCKET_ERROR == iRet ){
                _tprintf( TEXT("\r\nsend(): %d\r\n\r\n"), WSAGetLastError() ); __leave;
                }
            dwLeft  -= iRet;
            dwIndex += iRet;

            dwBytesTransferred += iRet;
            }

        // Reading and sending.
        while( ReadFile( hFile, bBuffer, BUF_SIZE, &dwSize, NULL ) && dwSize ){
            dwLeft  = dwSize;
            dwIndex = 0;
            while( dwLeft > 0 ){
                iRet = send( Socket, (char*) &bBuffer[dwIndex], dwLeft, 0 );
                if( SOCKET_ERROR == iRet ){
                    _tprintf( TEXT("\r\nsend(): %d\r\n\r\n"), WSAGetLastError() ); __leave;
                    }
                dwLeft  -= iRet;
                dwIndex += iRet;

                dwBytesTransferred += iRet;

                _tprintf( TEXT("Sending file: %d of %d bytes.\r"), dwBytesTransferred - HEADER_SIZE, dwDataSize - HEADER_SIZE );
                }
            }

        _tprintf( TEXT("\r\n") );

        dwDataSize         = 0;
        dwBytesTransferred = 0;
        dwIndex            = 0;
        dwSize             = 0;

        CloseHandle( hFile );
        hFile = INVALID_HANDLE_VALUE;

        while( iRet = recv( Socket, (char*) &bBuffer[dwIndex], BUF_SIZE - dwIndex, 0 ) ){
            if( SOCKET_ERROR == iRet ){
                _tprintf( TEXT("\r\nrecv(): %d\r\n\r\n"), WSAGetLastError() ); __leave;
                }

            dwBytesTransferred += iRet;

            // First receipt.
            if( 0 == dwDataSize ){
                // Bad packet.
                if( iRet < 4 ){ __leave; }

                // Getting the data size.
                CopyMemory( &dwDataSize, bBuffer, sizeof( dwDataSize ) );

                // Bad packet.
                if( dwDataSize < HEADER_SIZE ){ __leave; }
                }

            // If not the entire header has been received.
            if( dwBytesTransferred < HEADER_SIZE ){
                dwIndex += iRet;
                continue;
                }

            dwIndex = 0;

            // First receipt - creating a file.
            if( INVALID_HANDLE_VALUE == hFile ){
                wsprintfA( pszFileName, "%s.echo", (PSTR) &bBuffer[4] );

                hFile = CreateFileA( pszFileName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL,
                                     CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
                if( INVALID_HANDLE_VALUE == hFile ){ __leave; }

                // If part of the file has been received.
                if( dwBytesTransferred > HEADER_SIZE ){
                    WriteFile( hFile, &bBuffer[HEADER_SIZE], dwBytesTransferred - HEADER_SIZE, &dwSize, NULL );
                    }
                }
            else{
                // Otherwise writing to the file everything that has been received.
                WriteFile( hFile, (PVOID) bBuffer, iRet, &dwSize, NULL );
                }

            if( dwSize ){
                _tprintf( TEXT("Receiving file: %d of %d bytes.\r"), dwBytesTransferred - HEADER_SIZE, dwDataSize - HEADER_SIZE );
                }
            }

        _tprintf( TEXT("\r\n\r\n") );
        }
    __finally{
        if( Socket != INVALID_SOCKET ){
            shutdown( Socket, SD_BOTH );
            closesocket( Socket );
            }

        WSACleanup();

        if( hFile != INVALID_HANDLE_VALUE ){
            CloseHandle( hFile );
            }
        }
}

//##############################################################################################################//
int _tmain( int argc, _TCHAR* argv[] )
{
   int iArgc = __argc;

#ifdef UNICODE
   PCTSTR *ppArgv = (PCTSTR*) CommandLineToArgvW( GetCommandLine(), &iArgc );
#else
   PCTSTR *ppArgv = (PCTSTR*) __argv;
#endif

    if( iArgc < 4 ){
        _tprintf( TEXT("\r\n\r\nUsage: FileEchoClient.exe <ServerIP> <ServerPort> <FileName>\r\n\r\n") );
        return 0;
        }

    CHAR  szServerIP[32]       = {0};
    CHAR  szFileName[MAX_PATH] = {0};
    DWORD dwServerPort         = 0;

#ifdef UNICODE
    // Get server IP.
    WideCharToMultiByte( CP_ACP, 0, ppArgv[1], -1, szServerIP, sizeof( szServerIP ), NULL, NULL );
    WideCharToMultiByte( CP_ACP, 0, ppArgv[3], -1, szFileName, sizeof( szFileName ), NULL, NULL );
#else
    // Get server IP.
    lstrcpy( szServerIP, ppArgv[1] );
    lstrcpy( szFileName, ppArgv[3] );
#endif

    // Get server port.
    dwServerPort = _tstoi( ppArgv[2] );

    Start( szServerIP, dwServerPort, szFileName );

    return 0;
}

//##############################################################################################################//